#include "stdafx.h"

#include <windows.h>
#include <stdio.h>

const unsigned short BUFFER_SIZE = 3;
const unsigned long DELAY_CONSUMER_MS = 3000;
const unsigned long DELAY_PRODUCER_MS = 1000;

int Buffer[BUFFER_SIZE];
HANDLE SemCounterFreePositions;
HANDLE SemCounterBusyPositions;

DWORD WINAPI Consumer(LPVOID lpParam) 
{ 
	int ConsumerIndex = -1;
	int x;

	for (;;)
	{
		Sleep(DELAY_CONSUMER_MS);

		Completar

		ConsumerIndex = (ConsumerIndex +1) % BUFFER_SIZE;
		x = Buffer[ConsumerIndex];
		printf("Consumiendo en %d el valor %x\n",ConsumerIndex, x);

		Completar
	}
	
  return 0; 
} 

DWORD WINAPI Producer(LPVOID lpParam) 
{ 
	int ProducerIndex = -1;
	int x = 0;

	for (;;)
	{
		Sleep(DELAY_PRODUCER_MS);
		Completar
		ProducerIndex = (ProducerIndex +1) % BUFFER_SIZE;
		printf("Produciendo en %d el valor %d\n",ProducerIndex, x);
		Buffer[ProducerIndex] = x;
		x++;
		Completar
	}
	
  return 0; 
}

int _tmain(int argc, _TCHAR* argv[])
{
	HANDLE hThreadConsumer; 
	DWORD dwThreadIdConsumer;
	HANDLE hThreadProducer; 
	DWORD dwThreadIdProducer;

	SemCounterBusyPositions = CreateSemaphore(
		NULL,					// no security attributes
		0,						// initial count
	  BUFFER_SIZE,	// max count
    NULL);				// unnamed semaphore

	// unnamed semaphore
	SemCounterFreePositions = CreateSemaphore(NULL, BUFFER_SIZE, BUFFER_SIZE, NULL);						
	// Comprobacin de errores
	Completar

	hThreadConsumer = CreateThread( 
  	NULL,                 // no security attributes 
    0,                    // use default stack size  
    Consumer,							// thread function 
    NULL,		              // argument to thread function 
    0,                    // use default creation flags 
    &dwThreadIdConsumer);	// returns the thread identifier 


	hThreadProducer = CreateThread(NULL, 0, Producer, NULL, 0, &dwThreadIdProducer);
	Completar

	WaitForSingleObject(hThreadConsumer, INFINITE);
	WaitForSingleObject(hThreadProducer, INFINITE);

	CloseHandle(hThreadConsumer);
	CloseHandle(hThreadProducer);
	CloseHandle(SemCounterFreePositions);
	CloseHandle(SemCounterBusyPositions);

	return 0;
}